+
<template>
    <div class="content-grid content-grid--subpage content-grid--subpage-table">
        <Breadcrumbs :title="t(`routes.admin.children.users.name`)" />
        <div class="content-grid__header">
            <h1 class="back-link-title">{{ t(`routes.admin.children.users.name`) }}</h1>
            <div class="content-grid__filters">
                <SearchInput v-model="searchValue" />
            </div>
        </div>

        <Card :title="t(`user.mailing.sendMail`)" class="card--row-content">
            <BtnLink :name="t('routes.admin.children.mailing.name')"
                     :path="{ name: 'admin.children.mailing.index' }" />
        </Card>


        <h2>Liste des utilisateurs</h2>
        <Card>
            <DataTable :headers="memberHeader"
                       :is-loading="membersAreLoading"
                       :items="tableMembers"
                       :search-value="searchValue"
                       @delete="deleteMember" />
        </Card>

        <h2>Liste d'attente</h2>
        <Card v-if="tableWaitingMembers!=null && tableWaitingMembers.length > 0">
            <DataTable :headers="waitingMemberHeader"
                       :is-loading="waitingMembersAreLoading"
                       :items="tableWaitingMembers"
                       :search-value="searchValue"
                       @delete="deleteWaitingMember" />
        </Card>
        <p v-else>Aucun membre en attente.</p>

        <h2>Liste des administrateurs</h2>
        <Card v-if="tableAdmins!=null && tableAdmins.length > 0">
            <DataTable :headers="adminHeader"
                       :is-loading="adminsAreLoading"
                       :items="tableAdmins"
                       :search-value="searchValue"/>
        </Card>
        <p v-else>Aucun administrateur.</p>

    </div>
</template>

<script lang="ts" setup>
    import i18n from "@/i18n";
    import { useI18n } from "vue3-i18n";
    import { computed, onMounted, ref } from "vue";
    import { useMemberService, useWaitingMemberService } from "@/inversify.config";
    import { notifyError, notifySuccess } from "@/notify";
    import Card from "@/components/layout/Card.vue";
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import DataTable from "@/components/layout/DataTable.vue";
    import BtnLink from "@/components/layout/BtnLink.vue";
    import { Member } from "@/types/entities";
    import { WaitingMember } from "@/types/entities/waitingMember";
    import { Guid } from "@/types";
    import { RefSymbol } from "@vue/reactivity";
    import IconMail from "@/assets/icons/icon__mail.svg"

    const { t } = useI18n()
    const memberService = useMemberService()
    const waitingMemberService = useWaitingMemberService()

    const allMembers = ref<Member[]>([]);
    const allWaitingMembers = ref<WaitingMember[]>();
    const allAdmins = ref<Member[]>();

    const searchValue = ref("");

    const membersAreLoading = ref(false);
    const waitingMembersAreLoading = ref(false);
    const adminsAreLoading = ref(false);

    const tableMembers = computed(() => {
        let lang = i18n.getLocale()
        return allMembers.value.map((x: Member, index) => {
            const lotNumber = x.lots && x.lots.length > 0 ? x.lots[x.lots.length - 1].lotNumber : null;
            return {
                id: x.id,
                firstName: x.firstName,
                lastName: x.lastName,
                email: x.email,
                lotNumber: lotNumber,
                actions: {
                    notification: { name: `admin.children.users.children.notification`, params: { id: x.id } },
                    delete: true
                }
            }
        }).sort((a: any, b: any) => {
            if (a.lastName < b.lastName) {
                return -1;
            }
            if (a.lastName > b.lastName) {
                return 1;
            }
            return 0;
        }) as Member[];
    })

    const tableWaitingMembers = computed(() => {
        let lang = i18n.getLocale()
        return allWaitingMembers.value?.map((x: WaitingMember) => {
            return {
                id: x.id,
                firstName: x.firstName,
                lastName: x.lastName,
                email: x.email,
                phoneNumber: x.phoneNumber,
                actions: {
                    update: { name: `admin.children.users.children.add`, params: { id: x.id } },
                    delete: true
                }
            }
        }).sort((a: any, b: any) => {
            if (a.lastName < b.lastName) {
                return -1;
            }
            if (a.lastName > b.lastName) {
                return 1;
            }
            return 0;
        }) as WaitingMember[];
    })

    const tableAdmins = computed(() => {
        let lang = i18n.getLocale()
        return allAdmins.value?.map((x: Member) => {
            return {
                id: x.id,
                firstName: x.firstName,
                lastName: x.lastName,
                email: x.email,
                role: x.roles,
            }
        }).sort((a: any, b: any) => {
            if (a.lastName < b.lastName) {
                return -1;
            }
            if (a.lastName > b.lastName) {
                return 1;
            }
            return 0;
        }) as Member[];
    })

    onMounted(async () => {
        await loadAllMembers();
        await loadAllAdmins();
        await loadAllWaitingMembers();
    });

    async function loadAllMembers() {
        membersAreLoading.value = true;

        let members = await memberService.getAllMembersWithLotThisYear();
        if (members && members.length > 0) {
            members = members.filter(member => member.lots && member.lots.length > 0);
            allMembers.value = members;
        }
        membersAreLoading.value = false;
    }

    async function loadAllWaitingMembers() {
        waitingMembersAreLoading.value = true;

        let waitingMembers = await waitingMemberService.getAllWaitingMembers();
        if (waitingMembers && waitingMembers.length > 0) {
            allWaitingMembers.value = waitingMembers;
        }
        waitingMembersAreLoading.value = false;
    }

    async function loadAllAdmins() {
        adminsAreLoading.value = true;

        let admins = await memberService.getAllAdmins();

        if (admins && admins.length > 0) {
            allAdmins.value = admins;
        }
        adminsAreLoading.value = false;
    }

    async function deleteMember(member: any) {
        if (member?.id == null || !Guid.isValid(member.id ?? ""))
            return
        let confirmDelete = confirm(t("validation.user.delete.confirmation"));
        if (!confirmDelete)
            return;

        let response = await memberService.deleteMember(member.id)
        if (response.succeeded) {
            allMembers.value = allMembers.value.filter(x => x.id !== member.id)
            notifySuccess(t('validation.user.delete.success'))
        } else {
            let errorMessages = response.getErrorMessages('validation.user.delete',
                'validation.user.delete.errorOccured')
            notifyError(errorMessages[0])
        }
    }

    async function deleteWaitingMember(waitingMember: any) {
        if (waitingMember?.id == null || !Guid.isValid(waitingMember.id ?? ""))
            return
        let confirmDelete = confirm(t("validation.waitingMember.delete.confirmation"));
        if (!confirmDelete)
            return;
        let response = await waitingMemberService.deleteWaitingMember(waitingMember.id)
        if (response.succeeded) {
            allWaitingMembers.value = (allWaitingMembers.value || []).filter(x => x.id !== waitingMember.id)
            notifySuccess(t('validation.waitingMember.delete.success'))
        } else {
            let errorMessages = response.getErrorMessages('validation.user.delete',
                'validation.waitingMember.delete.errorOccured')
            notifyError(errorMessages[0])
        }
    }

    const memberHeader = [
        {
            text: t("user.firstName"),
            value: 'firstName',
            sortable: true,
            width: 125,
        },
        {
            text: t("user.lastName"),
            value: "lastName",
            sortable: true,
            width: 125,
        },
        {
            text: t("user.email"),
            value: "email",
            sortable: true,
            width: 250,
        },
        {
            text: t("user.lot"),
            value: "lotNumber",
            sortable: true,
            width: 155,
        },
        {
            text: t("global.table.actions"),
            value: "actions",
            width: 75
        },
    ];

    const waitingMemberHeader = [
        {
            text: t("user.firstName"),
            value: 'firstName',
            sortable: true,
            width: 125,
        },
        {
            text: t("user.lastName"),
            value: "lastName",
            sortable: true,
            width: 125,
        },
        {
            text: t("user.email"),
            value: "email",
            sortable: true,
            width: 250,
        },
        {
            text: t("global.table.actions"),
            value: "actions",
            width: 75
        },
    ];

    const adminHeader = [
        {
            text: t("user.firstName"),
            value: 'firstName',
            sortable: true,
            width: 125,
        },
        {
            text: t("user.lastName"),
            value: "lastName",
            sortable: true,
            width: 125,
        },
        {
            text: t("user.email"),
            value: "email",
            sortable: true,
            width: 250,
        },
        {
            text: t("user.role"),
            value: "role",
            sortable: true,
            width: 170,
        },
        {
            text: t("global.table.actions"),
            value: "actions",
            width: 75
        },
    ];

</script>
